<?php

header('Access-Control-Allow-Origin: abc');
defined('BASEPATH') OR exit('No direct script access allowed');
require_once(APPPATH.'libraries/google-calendar-api.php');

class Home extends CI_Controller {

	/*
	 * @Writer : Sagar Pund
	 * @Purpose: Front Home page.
	 * @CustomComment : 
	 * @LastUpdated : 15-Jan-2018
	*/	
	public function index()
	{
		$this->load->view('Template/Home/front_header');
		$this->load->view('Home/login');
		$this->load->view('Template/Home/front_footer');
	}

	public function test()
	{
		$this->load->view('Home/test');
	}

	public function LogOut() {

		$this->load->driver('cache'); 
		//$user_id = 
		//array( 'name' => 'user_id', 'value' => '', 'expire' => '0', 'domain' => '.localhost', 'prefix' => '' ); 
		//delete_cookie($user_id); 
		$this->session->sess_destroy(); 
		$this->cache->clean(); 
		session_unset();
		redirect(base_url());
	}


	public function sales_person_login()
	{

		if($this->validateUser()){

			/*if(!isset($_SESSION['access_token'])) {
				header('Location: google-login.php');
				exit();	
			}*/

			//echo "<pre>---";print_r($this->session->userdata('access_token'));die;

			if($this->session->userdata('access_token') == "")
			{	
				$this->load->view('Home/google-login');
			}
			else
			{
			
				$this->user_model->updateRecord(												
												  'tbl_sales_person',
												   array('access_token'=> $this->session->userdata('access_token')),
												   array('sales_id'=>$this->session->userdata('sales_id'))
											  );

				$this->load->view('Template/Home/front_header');
				$this->load->view('Home/index');
				$this->load->view('Template/Home/front_footer');
			}
		}
	}

	public function ajax_call(){
		try {
			// Get event details
			$event = $_POST['event_details'];

			$capi = new GoogleCalendarApi();

			// Get user calendar timezone
			$user_timezone = $capi->GetUserCalendarTimezone($this->session->userdata('access_token'));

			// Create event on primary calendar
			$event_id = $capi->CreateCalendarEvent('primary', $event['title'], $event['address'], $event['description'], $event['all_day'], $event['event_time'], $user_timezone, $this->session->userdata('access_token'));
			
			echo json_encode([ 'event_id' => $event_id ]);
		}
		catch(Exception $e) {
			header('Bad Request', true, 400);
		    echo json_encode(array( 'error' => 1, 'message' => $e->getMessage() ));
		}

	}

	public function Signin() {

		//echo "<pre>";print_r($_POST);

		$data = $this->user_model->CheckEmailPassword($_POST);
		$data = json_decode(json_encode($data),true);

		//echo "<pre>---";print_r($data);die;
		
		if(!empty($data))
		{
			$sessionArray= array(

				'sales_id' =>$data['sales_id'],
				'first_name	' =>$data['first_name'],
				'last_name' =>$data['last_name'],
				'email' =>$data['email'],
				'contact' =>$data['contact'],
				'full_name' => $data['first_name']." ".$data['last_name'],
				//'access_token' => $data['access_token'],
			);
			
			
			$this->session->set_userdata ($sessionArray);
			
			$return['link']= base_url()."booking";
			
			$return['msg']="Success";
				
			
		}else{
			$return['msg']="Fail";
		}
		echo json_encode($return);
	}

	public function forgetPassword(){

		$this->load->view('Home/forgetPassword');
	
	}

	public function ForgotPasswordSubmit() {
		
		$data = $this->user_model->GetDetailsByEmail($_POST['email']);

		//echo "<pre>";print_r($data);
		$aUserData = json_decode(json_encode($data),true);

		if(!empty($aUserData))
		{
			
			$link = base_url().'Home/ResetPassword/'.base64_encode($aUserData['sales_id']);
			
			$name = $aUserData['first_name']." ".$aUserData['last_name'];
			$email = $aUserData['email'];

			$password = $this->random_pass();
		
			$msg ='';

			$this->load->library('email');
			$config['protocol'] = 'ssmtp';
			$config['smtp_host'] = 'ssl://ssmtp.gmail.com';
			$config['smtp_port']    = '465';
			$config['smtp_timeout'] = '7';
			$config['smtp_user']    = 'greenonwindowsca@gmail.com';
			$config['smtp_pass']    = 'BlackMamba89#';
			$config['charset']    = 'iso-8859-1';
			$config['wordwrap'] = TRUE;
			$config['mailtype'] = 'html'; // Append This Line
			$config['validation'] = TRUE; // bool whether to validate email or not      

			$this->email->initialize($config);

			//$msg .= 'Hello '.$_POST['salesPName'].'<br/><br/>';

			$msg .= 'Hello '.$name.'<br/><br/>';
			$msg .= 'We received a request to reset your password.'.'<br/>';

			$msg .= 'your new password is <strong>'.$password."</strong><br/><br/>";
			
			$msg .= 'Happy Selling,'.'<br/>';
			$msg .= 'Chris George'.'<br/>';

			$this->email->from('greenonwindowsca@gmail.com');
			$this->email->to($email);
			$this->email->subject('Reset Password');
			$this->email->message($msg);

			if($this->email->send()){

				$this->user_model->updateRecord(
												
												'tbl_sales_person',
												array('password'=> md5($password)),
												array('sales_id'=>$aUserData['sales_id'])
											);

				echo"Success";
			}else{
				echo"Fail";
			}
		}
		else
		{
			echo"Fail";
		}
		
	}

	public function random_pass(){

	    $alphabet = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890';
	    $pass = array(); //remember to declare $pass as an array
	    $alphaLength = strlen($alphabet) - 1; //put the length -1 in cache
	    for ($i = 0; $i < 8; $i++) {
	        $n = rand(0, $alphaLength);
	        $pass[] = $alphabet[$n];
	    }
	    return implode($pass); //turn the array into a string

	}

	/*
	 * @Writer : Sagar Pund
	 * @Purpose: Save data.
	 * @CustomComment : 
	 * @LastUpdated : 16-Jan-2018
	*/	
	public function save()
	{
		//echo "<pre>";print_r($_POST);die;

		if(!empty($_POST)) {

			if( (!empty($_POST['date_time'])) && ($_POST['date_time']!='') ) {
				//$d = DateTime::createFromFormat('m-d-Y H:i A', $_POST['date_time1']);
				//$mysqldate = $d->format('Y-m-d H:i:s');
				$mysqldate = $_POST['date_time'];
			}
			else {
				//$d = DateTime::createFromFormat('m-d-Y H:i A', $_POST['date_time']);
				//$mysqldate = $d->format('Y-m-d H:i:s');
				$mysqldate = $_POST['monthedit'].'-'.$_POST['dayedit'].' '.$_POST['houredit'].':'.$_POST['minuteedit'].' '.$_POST['meridiemedit'];
			}

			$input_array = array(
							'name'             => $_POST['name'],
							'phone'	           => $_POST['phone'],
							'email'            => $_POST['email'],
							'interests'        => $_POST['interests'],
							'contact_time'     => $_POST['time_contact'],
							'preferred_method' => $_POST['preferred_method'],
							'appoint_datetime' => $mysqldate,
							'duration'		   => $_POST['durationedit'],
							'address'		   => $_POST['address'],
							'created_date'     => date('Y-m-d H:i:s'),
							'updated_date'     => date('Y-m-d H:i:s')
						);
			$a = $this->user_model->insertRecord('tbl_user_info',$input_array);
			print_r($a);
		}
	}

	private function validateUser()
	{	
		if((!empty($this->session->userdata('sales_id')) || $this->session->userdata('sales_id')!='')){
			return TRUE;
		}else{
			return false;
		}
	}
}
?>
